package org.ten60.netkernel.visualizer;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.zip.*;

import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.layer0.util.Utils;

public class ZipFileEntryRepresentation implements IReadableBinaryStreamRepresentation
{
	private final ZipFile mFile;
	private final ZipEntry mEntry;
	
	public ZipFileEntryRepresentation(ZipFile aFile, ZipEntry aEntry)
	{	mFile=aFile;
		mEntry=aEntry;
	}
	
	public String getEncoding()
	{	return null;
	}

	public void write(OutputStream aStream) throws IOException
	{	InputStream is = getInputStream();
		Utils.pipeNoClose(is, aStream);
	}

	public int getContentLength()
	{	return (int)mEntry.getSize();
	}

	public InputStream getInputStream() throws IOException
	{	return mFile.getInputStream(mEntry);
	}
}
