<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="xml"/>
	<xsl:variable name="trace-view">/visualizer</xsl:variable>
	<xsl:variable name="trace-raw">/visualizer</xsl:variable>
	<xsl:variable name="imgbase">/nkse/style/img/</xsl:variable>
	<xsl:variable name="explorer">/tools/explore/</xsl:variable>
	
	<xsl:variable name="duration" select="/capture/trace/end"/>
	
	<xsl:variable name="showTimings" select="count(/capture//trace[e-duration])>0"/>
	
	<xsl:template match="/capture">
		
		<div>
				<script type="text/javascript">
				<xsl:comment>
					
					function handleOver(e,id)
					{ 
var posx = 0;
	var posy = 0;
	if (!e) var e = window.event;
	if (e.pageX || e.pageY) 	{
		posx = e.pageX;
		posy = e.pageY;
	}
	else if (e.clientX || e.clientY) 	{
		posx = e.clientX + document.body.scrollLeft
			+ document.documentElement.scrollLeft;
		posy = e.clientY + document.body.scrollTop
			+ document.documentElement.scrollTop;
	}					
					
						e=document.getElementById(id);
					    e.style.top=posy+20;
						e.style.display= ""
					}

					function handleOut(id)
	                { document.getElementById(id).style.display= "none"
					}
					
					function getNamedChild(node,childName)
					{	if (node)
						{	for(child=node.firstChild; child; child=child.nextSibling )
							{	//console.log(child.nodeName);
								if (child.nodeType==1 &amp;&amp; child.nodeName==childName)
								{	return child;
								}
							}
						}
					}

					function handleExpand(event, id)
					{
						tr=document.getElementById(id);
						tab=tr.parentNode.parentNode;
						d=tr.getAttribute("depth");
						d=parseInt(d);
						img=getNamedChild(getNamedChild(getNamedChild(getNamedChild(tr,"TD"),"DIV"),"A"),"IMG");
					    expand=img.src.match("plus.png")
						if (expand)
						{  
							img.src="<xsl:value-of select="$imgbase"/>minus.png";
							for(sib=tr.nextSibling; sib; sib=sib.nextSibling )
							{   if (sib.nodeType==1 )
								{	sibd=sib.getAttribute("depth");	
									if (sibd)
									{	//console.log(sibd);
										sibd=parseInt(sibd);
										if (sibd > d )
										{	sib.style.display="";
										}
										else if (sibd &lt;= d)
										{	break;
										}
										//fix [+] buttons - all must be expanded now
										img=getNamedChild(getNamedChild(getNamedChild(getNamedChild(sib,"TD"),"DIV"),"A"),"IMG");
										if (img)
										{	expand2=img.src.match("plus.png");
											if (expand2)
											{	img.src="<xsl:value-of select="$imgbase"/>minus.png";
											}
										}
									}
								}
							}
							tab.style.border.right="solid 1px transparent";
						}
						else
						{  img.src="/tools/introspect/pub/plus.png";
							for(sib=tr.nextSibling; sib; sib=sib.nextSibling )
							{   if (sib.nodeType==1 )
								{	sibd=sib.getAttribute("depth");	
									if (sibd)
									{	//console.log(sibd);
										if (sibd > d)
										{	sib.style.display="none";
										}
										else if (sibd &lt;= d)
										{	break;
										}
									}
								}
							}
							tab.style.border.right="none";
						}
					
						//reflow striping
						even=tr.className.match("evenrow");
						for(sib=tr.nextSibling; sib; sib=sib.nextSibling )
						{   if (sib.nodeType==1 &amp;&amp; sib.style.display=="")
							{  
								if (even)
								{	sib.className="oddrow";
									even=false;
								}
								else
								{	sib.className="evenrow";
									even=true;
								}
							}
						}
					}
				</xsl:comment>
				</script>
				<div>
					<input type="button" value="back" onclick="parent.location='{$trace-view}/'" class="btn"/>
					<input type="button" value="save" onclick="parent.location='{$trace-raw}/{hash}/save'" class="btn"/>
				</div>
				
				<table class="vis-table" style="clear: both;">
					<tr class="vis-title">
						<td>Physical Endpoint / Callstack</td>
						<td>Space</td>
						<td>Verb</td>
						<td>Request Identifier</td>
						<xsl:if test="$showTimings">
							<td>Duration</td>
							<td>CPU</td>
						</xsl:if>
						<td>Exp</td>
						<td>Response Representation</td>
					</tr>
					<xsl:apply-templates select="trace"/>
				</table>
		</div>
	</xsl:template>
	
	<xsl:template match="trace">
		<xsl:variable name="ancestor-count" select="count(ancestor::trace)"></xsl:variable>
		<xsl:variable name="count" select="count(preceding::trace) + $ancestor-count -1"></xsl:variable>
		<xsl:variable name="class">
			<xsl:choose>
				<xsl:when test="$count mod 2 = 0">
					<xsl:text>evenrow</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>oddrow</xsl:text>
				</xsl:otherwise>  
			</xsl:choose>
		</xsl:variable>
		
		<xsl:variable name="depth"><xsl:value-of select="$ancestor-count "/></xsl:variable>
		<tr class="{$class}" onMouseOver2="handleOver(event,'i{$count}');"  onMouseOut2="handleOut('i{$count}');" depth="{$depth}" id="j{$count}">
			<td>
				<div style="margin-left: {$depth *1 }em; ">
					<xsl:choose>
						<xsl:when test="trace">
							<a onClick="handleExpand(event,'j{$count}')"><img src="{$imgbase}minus.png" border="0"/></a>
						</xsl:when>
						<xsl:otherwise>
							<img src="{$imgbase}blank.png" border="0"/>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:choose>
						<xsl:when test="$count &lt; 0">
							<xsl:value-of select="endpointShort"/>
						</xsl:when>
						<xsl:otherwise>
							<a href="{$trace-view}/{/capture/hash}/detail/{$count}">
								<xsl:choose>
									<xsl:when test="endpointShort"><xsl:value-of select="endpointShort"/></xsl:when>
									<xsl:otherwise>(from cache)</xsl:otherwise>
								</xsl:choose>
							</a>
						</xsl:otherwise>
					</xsl:choose>
				</div>
			</td>
			<td>
				<xsl:choose>
					<xsl:when test="endpointHomeHash">
						<a href="{$explorer}{endpointHomeHash}">
							<xsl:value-of select="endpointHomeContext"/>
						</a>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="endpointHomeContext"/>
					</xsl:otherwise>
				</xsl:choose>
			</td>
			<td><xsl:value-of select="verb"/></td>
			<td>
				<xsl:call-template name="wrapped">
					<xsl:with-param name="text"><xsl:value-of select="identifier"/></xsl:with-param>
				</xsl:call-template>
			</td>
			<xsl:if test="$showTimings">
				<td>
					<xsl:if test="e-percent">
						<div style="float:left; position: relative; width: {e-percent}%; background: #88F;">
							<div style="overflow: visible;"><xsl:value-of select="e-percent"/>%&#xa0;(<xsl:value-of select="e-duration"/>ms)</div>
						</div>
					</xsl:if>
				</td>
				<td>
					<xsl:if test="t-duration">
						<div style="float:left; position: relative; width: {t-percent}%; background: #88F;">
							<div style="overflow: visible;"><xsl:value-of select="t-percent"/>%&#xa0;(<xsl:value-of select="t-duration"/>ms)</div>
						</div>
					</xsl:if>
				</td>
			</xsl:if>
			<td>
				<xsl:choose>
					<xsl:when test="isExpired='true'">
						<div class="expired">&#160;</div>
					</xsl:when>
					<xsl:when test="isExpired='false'">
						<div class="valid">&#160;</div>
					</xsl:when>
					<xsl:otherwise>
						<div class="unknownExpiry">&#160;</div>
					</xsl:otherwise>
				</xsl:choose>
			</td>
			<td>
				<xsl:if test="responseException='true'">
					<xsl:attribute name="class">error</xsl:attribute>
				</xsl:if>
				<xsl:choose>
					<xsl:when test="responseClassShort='null'">
						<xsl:value-of select="responseClassShort"/>
					</xsl:when>
					<xsl:when test="responseName">
						<a href="{$trace-raw}/{/capture/hash}/response/{$count}">
							<xsl:value-of select="responseName"/> 
						</a>
					</xsl:when>
					<xsl:otherwise>
						<a href="{$trace-raw}/{/capture/hash}/response/{$count}">
							<xsl:value-of select="responseClassShort"/>
						</a>
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
		<xsl:apply-templates select="trace"/>
	</xsl:template>	
	
	<xsl:template name="wrapped">
		<xsl:param name="text"/>
		<xsl:choose>
			<xsl:when test="string-length($text)>20">
				<xsl:value-of select="substring($text,1,20)"/><span class="breakspace"><xsl:text> </xsl:text></span><xsl:call-template name="wrapped">
					<xsl:with-param name="text" select="substring($text,20+1)"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
</xsl:stylesheet>
